<template>
  <v-app :style="`background-color: ${bgColor}`">
    <v-app-bar app color="wrapped" dense>
      <v-btn icon fab color="white" @click="$router.back()">
        <v-icon>mdi-arrow-left</v-icon>
      </v-btn>
      <v-spacer></v-spacer>
      <v-app-bar-title class="white--text">
        Ledius
      </v-app-bar-title>
      <v-spacer></v-spacer>

      <v-menu offset-y v-if="isAuth">
        <template v-slot:activator="{ on, attrs }">
          <v-btn icon color="white" v-bind="attrs" v-on="on">
            <v-icon>mdi-dots-vertical</v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item link :to="{ name: 'Profile' }">
            <v-list-item-icon><v-icon>mdi-account</v-icon></v-list-item-icon>
            <v-list-item-title>Профиль</v-list-item-title>
          </v-list-item>
          <v-list-item link @click="logout">
            <v-list-item-icon><v-icon>mdi-logout</v-icon></v-list-item-icon>
            <v-list-item-title class="red--text">Выйти</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-app-bar>

    <v-main>
      <router-view />
    </v-main>

    <errors-dialog />
    <bottom-navigation />
  </v-app>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import BottomNavigation from '@/components/navigation/BottomNavigation.vue';
import ErrorsDialog from '@/components/errors/ErrorsDialog.vue';
import { AuthInfoResponse } from '@/api/courses';

@Component({
  components: {
    BottomNavigation,
    ErrorsDialog
  }
})
export default class App extends Vue {
  private get bgColor(): string {
    return this.$vuetify?.theme?.themes?.dark?.container?.toString() || '#000';
  }

  private get isAuth(): boolean {
    return this.$store.getters['auth/isAuth'];
  }

  private get authInfo(): AuthInfoResponse {
    return this.$store.getters['auth/info'];
  }

  private async mounted(): Promise<void> {
    await this.$store.dispatch('auth/check');
    await this.$store.dispatch('exchange/account/ensureAccount', this.authInfo.id);
  }

  private async logout(): Promise<void> {
    await this.$store.dispatch('auth/logout');
    await this.$router.push({
      name: 'Login'
    });
  }
}
</script>

<style>
@import url('https://fonts.googleapis.com/css2?family=Nunito:wght@400;700;800;900&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap');
</style>
